Subject: Re: FW: ssthressh

From: Randall Stewart <[email-masked]>
Date: Thu, 14 Jul 2005 08:13:55 -0400

Brian F. G. Bidulock wrote:
> Randall,
> 
> Not really research: results from testing in the same scenario that you
> describe (multi-homed through a hub, contest with TCP).  I did the
> experimentation a year or two ago when I was performing CMT testing.
> 
> The TCP contention results have not been published, only the CMT results
> were published to our website at http://www.openss7.org/sctp_perf.html

Interesting results... I have been playing around with KAME and 1000Mbit
links... and getting around 400Mb/s.... need to get setup to
make some pretty charts and graphs and put them up as well,
another thing for my "to do" list :-D

A question  or two below...

> Characteristics of the CMT algorithm that might assist with this are as
> follows:
> 
> * When I go to transmit, I select the "best" destination based on a
>   weighting that includes available send window considering congestion.
>   This causes lower performing destinations to fall away.
> 
> * The weighting also favors the same destination as was last transmitted
>   to if all other weighting factors are equal.  This adds persistence on
>   the same destination.  This is good for limiting gap reports as well
>   as helping with the bottleneck behavior.
> 
> * Once I choose the best destination, I send a much data as possible (is
>   available), without checking again.  Again, this is good for gap
>   reports as well as bottleneck behavior.

So you fill the destination completely until flightsize >= cwnd?
> 
> * When sending to the "best" destination is no longer possible because
>   the send window has closed, I rerun the selection algorithm and go
>   again.  (In the loop consideration is also given for max burst.)

So does this mean that when you perform the previous step.. and your
cwnd is full to the "former best destination", then you run your
selection algorithm and pick a new "best" one that has space
in its cwnd... and then repeat?

> 
> If you adjust your own CMT algorithm to similar characteristics, you
> might very well be able to recreate my bottleneck results with your own
> systems.  It shouldn't be too hard for someone to run an NS-2 simulation
> to figure out just what is happening and the importance of some aspects
> of the algorithm.
> 

Jana is working on the CMT algorithm .. he has asked me to test it
and I think I will finally get a chance this week to turn it on and
see how it does... I don't think he has implemented any of the
algorithms you enumerate above... maybe he should :-D

I will first test what he has put into the CVS base... and then
we will need to think about making some adjustments accordingly :-0

R

-- 
Randall Stewart
ITD - Cisco Systems Inc.
803-345-0369 <or> 815-342-5222 (cell)